searchNodes=[{"doc":"Req plugin for Phoenix.Ecto.SQL.Sandbox . ReqSandbox simplifies making concurrent, transactional requests to a Phoenix server. Just before making a request, the sandbox metadata is applied via the specified request header. If there is no metadata available, then ReqSandbox creates a new sandbox session and saves the metadata for future requests. This is mostly useful in client test environments to ensure logical isolation between concurrent tests. Usage The Ecto SQL Sandbox Usage Guide contains a full demonstration of the sandbox features. Mix . install ( [ { :req , &quot;~&gt; 0.3.0&quot; } , { :req_sandbox , &quot;~&gt; 0.1.0&quot; } ] ) req = Req . new ( base_url : &quot;http://localhost:4000&quot; |&gt; ReqSandbox . attach ( ) Req . post! ( req , url : &quot;/api/posts&quot; , json : %{ &quot;post&quot; =&gt; %{ &quot;msg&quot; =&gt; &quot;Hello, world!&quot; } } ) . body # =&gt; %{&quot;data&quot; =&gt; %{&quot;id&quot; =&gt; 2, &quot;msg&quot; =&gt; &quot;Hello, world!&quot;}} ReqSandbox . delete! ( req ) # =&gt; &quot;BeamMetadata (g2gCZAACdjF0AAAAA2QABW93bmVyWGQAInZ2ZXMzM2o1LWxpdmVib29...)&quot; License MIT License. Copyright (c) 2022 Michael A. Crumm Jr.","ref":"ReqSandbox.html","title":"ReqSandbox","type":"module"},{"doc":"Attaches to a Req request. Options :sandbox_url - The path to the sandbox. The default value is &quot;/sandbox&quot; . :sandbox_header - The header to put on the request. The default value is :user_agent . :sandbox_header_token - If provided, the sandbox header value. Otherwise, an existing token from the process will be used. If no token is found, one will be requested from the path at :sandbox_url . The default value is nil .","ref":"ReqSandbox.html#attach/2","title":"ReqSandbox.attach/2","type":"function"},{"doc":"Deletes the sandbox token from the process dictionary if it exists.","ref":"ReqSandbox.html#delete!/0","title":"ReqSandbox.delete!/0","type":"function"},{"doc":"Deletes the sandbox from the server and the process dictionary, if it exists.","ref":"ReqSandbox.html#delete!/1","title":"ReqSandbox.delete!/1","type":"function"},{"doc":"","ref":"changelog.html","title":"CHANGELOG","type":"extras"},{"doc":"Fixes a regression when using Req's :base_url option.","ref":"changelog.html#v0-1-1-2022-12-13","title":"CHANGELOG - v0.1.1 (2022-12-13)","type":"extras"},{"doc":"Initial release","ref":"changelog.html#v0-1-0-2022-10-25","title":"CHANGELOG - v0.1.0 (2022-10-25)","type":"extras"},{"doc":"~S&quot;&quot;&quot; __ __ _ _ \\ \\ / / | | | | \\ \\ /\\ / /__| | ___ ___ _ __ ___ ___| | \\ \\/ \\/ / _ \\ |/ __/ _ \\| &#39;_ ` _ \\ / _ \\ | \\ /\\ / __/ | (_| (_) | | | | | | __/_| \\/ \\/ \\___|_|\\___\\___/|_| |_| |_|\\___(_) Welcome to the sandbox setup guide! This guide contains a complete Phoenix application with a basic CRUD to demonstrate the features of ReqSandbox. The setup is pretty long so this message is here to let you know that by default the guide expects the following: - You are running a PostgreSQL server locally. - The db user is &quot;postgres&quot; and the password is &quot;postgres&quot;. - There exists (or the db user can create) a database named &quot;req_sandbox_guide&quot;. - Livebook can run a local Phoenix server on port 5001. If you need to adjust any of these assumptions, you need to make the necessary changes in this setup block. Note you can make changes here at any time and then run &quot;Reconnect and setup&quot; to restart your Livebook session. Once your Livebook session is up and running, follow the steps to examine how the Plug Phoenix.Ecto.SQL.Sandbox provides logical isolation to your HTTP requests. Happy hacking! &quot;&quot;&quot; # Modify these values to suit your environment pg_host = &quot;127.0.0.1&quot; pg_user = &quot;postgres&quot; pg_pass = &quot;postgres&quot; pg_db = &quot;req_sandbox_guide&quot; port = 5001 # END: user values Mix . install ( [ { :req , &quot;~&gt; 0.3.0&quot; } , { :req_sandbox , &quot;~&gt; 0.1.0&quot; } , { :plug_cowboy , &quot;~&gt; 2.5&quot; } , { :jason , &quot;~&gt; 1.0&quot; } , { :phoenix , &quot;~&gt; 1.7.0-dev&quot; , github : &quot;phoenixframework/phoenix&quot; , commit : &quot;6e23d1a&quot; } , { :phoenix_ecto , &quot;~&gt; 4.0&quot; } , { :ecto_sql , &quot;~&gt; 3.8.0&quot; } , { :postgrex , &quot;~&gt; 0.16&quot; } , { :kino , &quot;~&gt; 0.7&quot; } ] ) Application . put_env ( :req_sandbox_guide , Repo , url : &quot;ecto:// \#{ pg_user } : \#{ pg_pass } @ \#{ pg_host } / \#{ pg_db } &quot; , pool : Ecto.Adapters.SQL.Sandbox , ownership_timeout : :timer . hours ( 24 ) ) Application . put_env ( :req_sandbox_guide , ReqSandboxGuide.Endpoint , render_errors : [ formats : [ json : ReqSandboxGuide.ErrorJSON ] , layout : false ] , http : [ ip : { 127 , 0 , 0 , 1 } , port : port ] , server : true , secret_key_base : String . duplicate ( &quot;a&quot; , 64 ) ) Application . put_env ( :phoenix , :json_library , Jason ) # ------ Do not modify anything below this line ------- defmodule Repo do use Ecto.Repo , otp_app : :req_sandbox_guide , adapter : Ecto.Adapters.Postgres end defmodule Migration0 do use Ecto.Migration def change do create ( table ( &quot;posts&quot; ) ) do add ( :msg , :string ) timestamps ( type : :utc_datetime_usec ) end end end defmodule Post do use Ecto.Schema import Ecto.Changeset schema &quot;posts&quot; do field ( :msg , :string ) timestamps ( type : :utc_datetime_usec ) end def changeset ( post , attrs ) do post |&gt; cast ( attrs , [ :msg ] ) |&gt; validate_required ( [ :msg ] ) end end defmodule ReqSandboxGuide do def controller do quote do use Phoenix.Controller , namespace : ReqSandboxGuide , formats : [ :json ] import Plug.Conn unquote ( verified_routes ( ) ) end end def verified_routes do quote do use Phoenix.VerifiedRoutes , endpoint : ReqSandboxGuide.Endpoint , router : Router end end defmacro __using__ ( which ) when is_atom ( which ) do apply ( __MODULE__ , which , [ ] ) end end defmodule ReqSandboxGuide.PostController do use ReqSandboxGuide , :controller action_fallback ( ReqSandboxGuide.FallbackController ) def index ( conn , _params ) do posts = Repo . all ( Post ) render ( conn , :index , posts : posts ) end def create ( conn , %{ &quot;post&quot; =&gt; post_params } ) do changeset = % Post { } |&gt; Post . changeset ( post_params ) with { :ok , % Post { } = post } &lt;- Repo . insert ( changeset ) do conn |&gt; put_status ( :created ) |&gt; put_resp_header ( &quot;location&quot; , ~p&quot;/posts/ \#{ post } &quot; ) |&gt; render ( :show , post : post ) end end def show ( conn , %{ &quot;id&quot; =&gt; id } ) do post = Repo . get! ( Post , id ) render ( conn , :show , post : post ) end def delete ( conn , %{ &quot;id&quot; =&gt; id } ) do post = Repo . get! ( Post , id ) with { :ok , % Post { } } &lt;- Repo . delete ( post ) do send_resp ( conn , :no_content , &quot;&quot; ) end end end defmodule ReqSandboxGuide.FallbackController do use ReqSandboxGuide , :controller # This clause handles errors returned by Ecto&#39;s insert/update/delete. def call ( conn , { :error , % Ecto.Changeset { } = changeset } ) do conn |&gt; put_status ( :unprocessable_entity ) |&gt; put_view ( json : ReqSandboxGuide.ChangesetJSON ) |&gt; render ( &quot;error.json&quot; , changeset : changeset ) end # This clause is an example of how to handle resources that cannot be found. def call ( conn , { :error , :not_found } ) do conn |&gt; put_status ( :not_found ) |&gt; put_view ( json : ReqSandboxGuide.ErrorJSON ) |&gt; render ( :&quot;404&quot; ) end end defmodule ReqSandboxGuide.PostJSON do def index ( %{ posts : posts } ) do %{ data : for ( post &lt;- posts , do : data ( post ) ) } end def show ( %{ post : post } ) do %{ data : data ( post ) } end defp data ( % Post { } = post ) do %{ id : post . id , msg : post . msg } end end defmodule ReqSandboxGuide.ChangesetJSON do def translate_errors ( changeset ) do Ecto.Changeset . traverse_errors ( changeset , &amp; translate_error / 1 ) end def error ( %{ changeset : changeset } ) do # When encoded, the changeset returns its errors # as a JSON object. So we just pass it forward. %{ errors : translate_errors ( changeset ) } end def translate_error ( { msg , _opts } ) do msg end end defmodule ReqSandboxGuide.ErrorJSON do def render ( template , _assigns ) do %{ errors : %{ detail : Phoenix.Controller . status_message_from_template ( template ) } } end end defmodule Router do use Phoenix.Router pipeline :api do plug ( :accepts , [ &quot;json&quot; ] ) end scope &quot;/&quot; , ReqSandboxGuide do pipe_through ( :api ) get ( &quot;/&quot; , PostController , :index ) resources ( &quot;/posts&quot; , PostController , except : [ :new , :edit , :update ] ) end end defmodule ReqSandboxGuide.Endpoint do use Phoenix.Endpoint , otp_app : :req_sandbox_guide # In an integration server environment, you want to configure timeout # to something reasonable for your workflows. Automated tests usually # require only a short timeout, but short timeouts can interfere with # manual user testing (and demonstrations like this one!) and produce # unexpected results. plug ( Phoenix.Ecto.SQL.Sandbox , at : &quot;/sandbox&quot; , repo : Repo , timeout : :timer . hours ( 24 ) ) plug ( Plug.Parsers , parsers : [ :urlencoded , :multipart , :json ] , pass : [ &quot;*/*&quot; ] , json_decoder : Phoenix . json_library ( ) ) plug ( Router ) end # Creates the guide&#39;s database. # It may already exist and that&#39;s okay. { :ok , pgx } = Postgrex . start_link ( hostname : pg_host , username : pg_user , password : pg_pass , database : &quot;&quot; ) Postgrex . query ( pgx , &quot;CREATE DATABASE \#{ pg_db } &quot; , [ ] ) Process . unlink ( pgx ) Process . exit ( pgx , :shutdown ) # Configures migrations _ = Repo . __adapter__ ( ) . storage_down ( Repo . config ( ) ) :ok = Repo . __adapter__ ( ) . storage_up ( Repo . config ( ) ) # Starts the Repo and the Endpoint { :ok , _ } = Supervisor . start_link ( [ Repo , ReqSandboxGuide.Endpoint ] , strategy : :one_for_one ) # Runs migrations Ecto.Migrator . run ( Repo , [ { 0 , Migration0 } ] , :up , all : true , log_migrations_sql : :debug ) # Puts the Repo in manual mode Ecto.Adapters.SQL.Sandbox . mode ( Repo , :manual )","ref":"usage.html","title":"Ecto SQL Sandbox Usage Guide","type":"extras"},{"doc":"Welcome back to the sandbox guide! Once the setup above is complete, we can begin making requests! First let's explore sandboxes from the server's perspective. The setup block of this Livebook defines a Repo module that acts as our app's data store. It is configured to use the Ecto.Adapters.SQL.Sandbox pool to checkout a DBConnection . The pool has been set to :manual mode, which requires that each process explicitly checkout a connection before it can be used. Our sample app defines a simple Post schema to demonstrate the sandbox. Try to fetch all of the Posts without first checking out a connection (hint: this raises an error). # Remember, this raises an error! Keep going :) Repo . all ( Post ) Did you receive a DBConnection.OwnershipError in the last step? Good! That means the sandbox's manual mode is working correctly. You must first checkout a DBConnection from the Sandbox: :ok = Ecto.Adapters.SQL.Sandbox . checkout ( Repo ) Once you have checked out a connection, you can query the database. Let's try to fetch all the posts again: Repo . all ( Post ) Since the list of posts is empty, now is a good time to insert one: post = Repo . insert! ( % Post { msg : &quot;hello, world!&quot; } ) ...and we can select the post we inserted: Repo . get! ( Post , post . id ) ...and afterwards we checkin the connection: :ok = Ecto.Adapters.SQL.Sandbox . checkin ( Repo ) You have just observed how the Ecto SQL Sandbox pool provides logical isolation for concurrent processes. If you think you might have missed it, go back and re-evaluate all of the steps in this section. You will notice that the list of Posts is always empty. Sandbox sessions are transactional, and when the connection is checked in, the transaction is rolled back. The changes are accessible only within the transaction and they are never actually committed to the database.","ref":"usage.html#introduction-to-ecto-sql-sandboxes","title":"Ecto SQL Sandbox Usage Guide - Introduction to Ecto SQL Sandboxes","type":"extras"},{"doc":"This Livebook is configured with a Phoenix server and a simple API for creating and retrieving posts. You can use the Req requests package to access the API. Just like before, try to fetch some posts, this time as an external client using the API. Just like before, without a sandbox connection, this request will fail: req = Req . new ( base_url : ReqSandboxGuide.Endpoint . url ( ) , headers : [ { :accept , &quot;application/json&quot; } ] , max_retries : 0 ) # Remember, I return errors! Keep going :) Req . get! ( req , url : &quot;/posts&quot; ) . body For concurrent and transactional tests with external HTTP clients, the plug Phoenix.Ecto.SQL.Sandbox exposes a route on your app's Endpoint where external clients may POST to spawn a new sandbox session and DELETE to stop an active session. The docs use the example route &quot;/sandbox&quot; : # lib/my_app_web/endpoint.ex plug Phoenix.Ecto.SQL.Sandbox , at : &quot;/sandbox&quot; , repo : MyApp.Repo , timeout : 15_000 # the default Link: https://hexdocs.pm/phoenix_ecto/Phoenix.Ecto.SQL.Sandbox.html#module-concurrent-end-to-end-tests-with-external-clients This Livebook is configured using the &quot;/sandbox&quot; route. We can use the Req requests package to create res = Req . post! ( req , url : &quot;/sandbox&quot; ) sandbox_token = res . body Now create one or more posts: msg = Kino.Input . text ( &quot;Message&quot; , default : &quot;Hello, world!&quot; ) result = Req . post! ( req , url : &quot;/posts&quot; , json : %{ post : %{ msg : Kino.Input . read ( msg ) } } , user_agent : sandbox_token ) . body ...and fetch the last post created: last_id = get_in ( result , ~w|data id| ) Req . get! ( req , url : &quot;/posts/ \#{ last_id } &quot; , user_agent : sandbox_token ) . body [ &quot;data&quot; ] ...or fetch the list: posts = Req . get! ( req , url : &quot;/posts&quot; , user_agent : sandbox_token ) . body [ &quot;data&quot; ] Kino.DataTable . new ( posts , name : &quot;Posts&quot; ) When you are done, delete the sandbox session: Req . delete! ( req , url : &quot;/sandbox&quot; , user_agent : sandbox_token ) . body ...and that is all! Just remember to manage your sandbox token and include it on all requests, or...","ref":"usage.html#concurrent-http-tests","title":"Ecto SQL Sandbox Usage Guide - Concurrent HTTP Tests","type":"extras"},{"doc":"ReqSandbox simplifies the process of making sandbox requests to a Phoenix server. By attaching the ReqSandbox plugin to your Req request, the sandbox requirement is handled automatically: req = req |&gt; ReqSandbox . attach ( ) for n &lt;- 1 .. 3 do Req . post! ( req , url : &quot;/posts&quot; , json : %{ post : %{ msg : &quot;Hello, \#{ n } !&quot; } } ) end |&gt; Enum . map ( fn %{ body : %{ &quot;data&quot; =&gt; data } } -&gt; data end ) |&gt; Kino.DataTable . new ( name : &quot;Created Posts&quot; ) ReqSandbox even works inside Tasks: Task . async_stream ( 1 .. 3 , fn _ -&gt; msg = &quot;Hello, \#{ DateTime . utc_now ( ) } !&quot; Req . post! ( req , url : &quot;/posts&quot; , json : %{ post : %{ msg : msg } } ) end ) |&gt; Enum . map ( fn { _ , %{ body : %{ &quot;data&quot; =&gt; data } } } -&gt; data end ) |&gt; Kino.DataTable . new ( name : &quot;Created Posts (Task.async_stream)&quot; ) Perform one last listing: req |&gt; Req . get! ( url : &quot;/posts&quot; ) |&gt; Map . fetch! ( :body ) |&gt; Map . fetch! ( &quot;data&quot; ) |&gt; Kino.DataTable . new ( name : &quot;Posts&quot; ) ...and when you are finished, delete the active sandbox session: _ = ReqSandbox . delete! ( req )","ref":"usage.html#reqsandbox-to-the-reqscue","title":"Ecto SQL Sandbox Usage Guide - ReqSandbox to the reqscue! 🚀","type":"extras"}]